/* 
Beispielprogramm fr:
- statisches und dynamisches Binden einer DLL
- Verwendung von shared memory

Die Anwendung bindet die DLL entweder dynamisch oder statisch (auskommentiert)



ACHTUNG: Fr das dynamische Binden wird der #include <afxext.h> bentigt. 
(Wird in StdAfx.h eingebunden)

Mit producer wird das shared memory auf den Wert 2 gesetzt. Um sicherzugehen,
dass der Wert gesetzt wurde wird dieser nach dem Setzen ausgelesen.

Anschliessend kann mit consumer der Wert 2 ausgelesen werden

consumer belibt nach dem Setzen und Auslesen des shared Memorys aktiv, damit 
die DLL nicht terminiert und damit das shared memory nicht freigegeben wird.

*/


#include "StdAfx.h"
#include <conio.h>

//Fr statisches Binden entkommentieren
/*	 __declspec (dllimport) int readValue ();
	 __declspec (dllimport) void addValue (int);
*/

int main(int argc, char* argv[])
{
	int i=0;

//Dynamisches Binden
	typedef void (LPADD)(int);
	typedef int (LPREAD)(void);
	HINSTANCE hDLL = NULL;
	LPADD* lpAddValue;
	LPREAD* lpReadValue;


	hDLL = ::LoadLibrary("C:\\Programme\\Microsoft Visual Studio\\MyProjects\\SharedMem\\SharedMem\\Debug\\SharedMem.dll");
	if( hDLL == NULL )
		printf("Could not load the DLL\n");
	else{
		lpAddValue = (LPADD*)::GetProcAddress(hDLL, "addValue");
		lpReadValue = (LPREAD*)::GetProcAddress(hDLL, "readValue");
	}
//Ende dynamisches Binden

	printf("Setze Wert in Dll auf 2\n");

//	addValue(2);//Statisch
	(*lpAddValue)(2);//Dynamisch

	printf("Auslesen des Wertes in der DLL\n");

//	i=readValue(); //Statisch
	i=(*lpReadValue)(); //Dynamisch
	
	printf("Wert= %d\n",i);
	while (!kbhit()); //DLL am Leben halten
	return 0;
}

